#include <bits/stdc++.h>
using namespace std;
#define int int64_t

vector<int> a;
vector<int> tree;
vector<int> p;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build (2 * v + 1, l, m);
    build (2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void push(int v, int l, int r) {
    if (p[v] == 0) {
        return;
    }
    int m = (l + r) / 2;
    tree[2 * v + 1] = (m - l) * p[v];
    p[2 * v + 1] = p[v];
    tree[2 * v + 2] = (r - m) * p[v];
    p[2 * v + 2] = p[v];
    p[v] = 0;
    return;
}

void update(int v, int l, int r, int ql, int qr, int x) {
    if (ql >= r || l >= qr) {
        return;
    }
    if (ql <= l && r <= qr) {
        tree[v] = (r - l) * x;
        p[v] = x;
        return;
    }
    push(v, l, r);
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, ql, qr, x);
    update(2 * v + 2, m, r, ql, qr, x);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || ql >= r) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    push(v, l, r);
    int m = (l + r) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

void solve() {
    int n;
    cin >> n;
    a = vector<int> (n + 1, 0);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    p = vector<int>(4 * (n + 1), 0);
    tree = vector<int> (4 * (n + 1), 0);
    build(0, 1, n + 1);
    vector<deque<pair<int,int> > > mn(n + 1);
    vector<pair<int,int> > sc(n + 1);
    for (int i = 1; i <= n; i++) {
        mn[i].push_back({a[i], i});
        sc[i] = {i, i};
    }
    vector<int> prev(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        prev[i] = prev[i - 1] + a[i];
    }
    for (int i = 1; i <= n - 1; i++) {
        int k;
        cin >> k;
        int x = k;
        int y = k + 1;
        while (mn[x].size() > 0) {
            pair<int,int> w = mn[x][mn[x].size() - 1];
            pair<int,int> e = mn[y][0];
            if (w.second < e.second) {
                update(0, 1, n + 1, w.second, e.second, min(w.first, e.first));
            }
            if (w.first > e.first) {
                break;
            }
            mn[x].pop_back();
        }
        sc[x].second = sc[y].second;
        for (int j = k + 1; j < n; j++) {
            swap(sc[j], sc[j + 1]);
        }
        if (mn[x].size() >= mn[y].size()) {
            while (mn[y].size() > 0) {
                mn[x].push_back(mn[y][0]);
                mn[y].pop_front();
            }
        }
        if (mn[y].size() > mn[x].size()) {
            while (mn[x].size() > 0) {
                mn[y].push_front(mn[x][mn[x].size() - 1]);
                mn[x].pop_back();
            }
            swap(mn[y], mn[x]);
        }
        for (int j = k + 1; j < n; j++) {
            swap(mn[j], mn[j + 1]);
        }
        cout << get(0, 1, n + 1, sc[x].first, sc[x].second + 1) - (prev[sc[x].second] - prev[sc[x].first - 1]) << '\n';
    }
}

int32_t main() {
    solve();
}
